LIST L=ON, P=16C84
; *************************************************************************
;               10 DIGIT BCD VIEWER version 3
; *************************************************************************
                include "PIC84HDR.EQU"
; *************************************************************************
                STD             equ 3H    	;vstup STD
		INKEY		equ 2H	  	;tlacitko "FUNCTION"
		OUTRES		equ 0H	  	;reset 4017
		OUTCLK		equ 1H	  	;posouvani 4017
		SETKEY		equ 7H		;tlacitko "SAVEMEM"
; *************************************************************************
; registers
; *************************************************************************			
		NO1		equ 0CH				
		NO2		equ 0DH
		NO3		equ 0EH
		NO4		equ 0FH
		NO5		equ 10H
		NO6		equ 11H
		NO7		equ 12H
		NO8		equ 13H
		NO9		equ 14H
		NO10		equ 15H
		NO11		equ 16H
		NO12		equ 17H
		NO13		equ 18H
		DIG1		equ 19H
		DIG2		equ 1AH
		DIG3		equ 1BH
		DIG4		equ 1CH
		DIG5		equ 1DH
		DIG6		equ 1EH
		DIG7		equ 1FH
		DIG8		equ 20H
		DIG9		equ 21H
		JEDN            equ 22H
		DESI		equ 23H
		STOV		equ 24H
		TISI		equ 25H
		DESTIS		equ 26H
		SEL1		equ 27H
		SEL2		equ 28H
		CONT		equ 29H
		RPT1		equ 2AH
		RPT2		equ 2BH
		COUNT		equ 2CH
		OPC		equ 2DH
		SHUT		equ 2EH
		NBRS		equ 2FH
; *************************************************************************

		org Reset
		goto Start




;**************************************************************************
; VIEWNUMBER - PROCEDURA ZOBRAZOVANI CISEL NA DISPLEJI
;**************************************************************************
ViewNumber	movlw b'10000000'
		TRIS TRIS_B
		movlw .155		;Hlavni procedura zobrazovani	
		subwf NBRS,W		;space=255
		btfss SWR,Z		
		goto Down		;ne
Display		call Clear		;ano
		bsf PORT_A,OUTRES
		call Delay
		bcf PORT_A,OUTRES
		movfw DIG1
		movwf OPC
		call Decoder
		movwf PORT_B
		call Clear
		bsf PORT_A,OUTCLK
		bcf PORT_A,OUTCLK
		movfw DIG2
		movwf OPC
		call Decoder
		movwf PORT_B
		call Clear
		bsf PORT_A,OUTCLK
		bcf PORT_A,OUTCLK
		movfw DIG3
		movwf OPC
		call Decoder
		movwf PORT_B
		call Clear
		bsf PORT_A,OUTCLK
		bcf PORT_A,OUTCLK
		movfw DIG4
		movwf OPC
		call Decoder
		movwf PORT_B
		call Clear
		bsf PORT_A,OUTCLK
		bcf PORT_A,OUTCLK
		movfw DIG5
		movwf OPC
		call Decoder
		movwf PORT_B
		call Clear
		bsf PORT_A,OUTCLK
		bcf PORT_A,OUTCLK
		movfw DIG6
		movwf OPC
		call Decoder
		movwf PORT_B
		call Clear
		bsf PORT_A,OUTCLK
		bcf PORT_A,OUTCLK
		movfw DIG7
		movwf OPC
		call Decoder
		movwf PORT_B
		call Clear
		bsf PORT_A,OUTCLK
		bcf PORT_A,OUTCLK
		movfw DIG8
		movwf OPC
		call Decoder
		movwf PORT_B
		call Clear
		bsf PORT_A,OUTCLK
		bcf PORT_A,OUTCLK
		movfw DIG9
		movwf OPC
		call Decoder
		movwf PORT_B
		call Clear
		bsf PORT_A,OUTCLK
		bcf PORT_A,OUTCLK
		return
Clear		call Delay	  		;Vymaze displej a zavede Delay
		call Delay
		movlw b'11111111'
		movwf PORT_B
		return	
Decoder		movfw OPC		
		addwf PCL,f
		retlw b'01000000'	;0	0
		retlw b'01111001'	;1	1
		retlw b'00100100'	;2	2
		retlw b'00110000'	;3	3
		retlw b'00011001'	;4	4
		retlw b'00010010'	;5	5
		retlw b'00000010'	;6	6
		retlw b'01111000'	;7	7
		retlw b'00000000'	;8	8
		retlw b'00010000'	;9	9
		retlw b'01000000'	;0	10
		retlw b'00101101'	;*	11
		retlw b'00110110'	;#	12
		retlw b'00001000'	;A	13
		retlw b'00000011'	;b	14
		retlw b'01000110'	;C	15
		retlw b'00001001'	;H	16
		retlw b'01100000'	;J	17
		retlw b'01000110'	;[	18
		retlw b'00001110'	;F	19
		retlw b'00000111'	;t	20
		retlw b'00000110'	;E	21
		retlw b'01000111'	;L	22
		retlw b'00111111'	;-	23
		retlw b'01111111'       ;	24
Down		incf NBRS		;SPACE=SPACE+1
		movlw .155	
		subwf NBRS,W		;space=255?
		btfss SWR,Z
		goto Display		;ne
		movfw NO12		;ano
		movwf NO13
		movfw NO11
		movwf NO12
		movfw NO10
		movwf NO11
		movfw NO9
		movwf NO10
		movfw NO8		
		movwf NO9 
		movfw NO7
		movwf NO8 
		movfw NO6
		movwf NO7 
		movfw NO5
		movwf NO6 
		movfw NO4
		movwf NO5 
		movfw NO3
		movwf NO4 
		movfw NO2 
		movwf NO3 
		movfw NO1
		movwf NO2 
		movlw .23
		movwf NO1
		goto Display


;**************************************************************************
; HLAVNI FUNKCNI PROCEDURY 
;**************************************************************************
Viewing		movfw NO1		;zobrazuje se odecitac XXXXXXXXXX
		movwf DIG1
		movfw NO2
		movwf DIG2
		movfw NO3
		movwf DIG3
		movfw NO4
		movwf DIG4
		movfw NO5
		movwf DIG5
		movfw NO6
		movwf DIG6
		movfw NO7
		movwf DIG7
		movfw NO8
		movwf DIG8
		movfw NO9
		movwf DIG9
		call ViewNumber
		btfss PORT_B,SETKEY
		goto SaveNumber
		btfss PORT_A,STD
		clrf CONT
		btfsc PORT_A,STD
		call StdGoes	
		btfss PORT_A,INKEY
		goto Loop1
		goto Viewing		
Loop1		call Delay
		btfsc PORT_A,INKEY
		goto Viewing
Loop11		btfss PORT_A,INKEY
		goto Loop11
ViewSecond	movfw NO5		;Zobrazuje sel ---OFF---
		movwf DIG1
		movfw NO6
		movwf DIG2
		movfw NO7
		movwf DIG3
		movfw NO8
		movwf DIG4
		movfw NO9
		movwf DIG5
		movfw NO10
		movwf DIG6
		movfw NO11
		movwf DIG7
		movfw NO12
		movwf DIG8
		movfw NO13
		movwf DIG9
		call ViewNumber
		decfsz SHUT
		goto jerry
		goto Navrat
jerry		btfss PORT_A,STD
		clrf CONT
		btfsc PORT_A,STD
		call StdGoes	
		btfss PORT_A,INKEY
		goto Loop50
		goto ViewSecond	
Loop50		call Delay
		btfsc PORT_A,INKEY
		goto ViewSecond
Loop510		btfss PORT_A,INKEY
		goto Loop510
		movlw .255
		movwf SHUT
		goto Counting
Navrat		movlw .255
		movwf SHUT
		goto Viewing
Counting        movfw JEDN		;zobrazuje se pocitadlo Ct___00000
		movwf DIG1
		movfw DESI
		movwf DIG2
		movfw STOV
		movwf DIG3
		movfw TISI
		movwf DIG4
		movfw DESTIS
		movwf DIG5
		movlw .24
		movwf DIG6
		movlw .24
		movwf DIG7
		movlw .20
		movwf DIG8
		movlw .15
		movwf DIG9
		call ViewNumber
		btfss PORT_A,STD
		clrf CONT
		btfsc PORT_A,STD
		call StdGoes	
		btfss PORT_A,INKEY
		goto Loop2
		goto Counting		
Loop2		call Delay
		btfsc PORT_A,INKEY
		goto Counting
Loop21		btfss PORT_A,INKEY
		goto Loop21
Mem1No		movfw SEL1		;Zobrazuje se SEL-1___00		
		movwf DIG1
		movfw SEL2
		movwf DIG2
		movlw .24
		movwf DIG3
		movlw .24
		movwf DIG4
		movlw .1
		movwf DIG5
		movlw .23
		movwf DIG6
		movlw .22
		movwf DIG7
		movlw .21
		movwf DIG8
		movlw .5
		movwf DIG9
		call ViewNumber
		btfss PORT_A,STD
		clrf CONT
		btfsc PORT_A,STD
		call StdGoes	
		btfss PORT_A,INKEY
		goto Loop3
		goto Mem1No		
Loop3		call Delay
		btfsc PORT_A,INKEY
		goto Mem1No
Loop31		btfss PORT_A,INKEY
		goto Loop31
Mem2No		movfw RPT1		;Zobrazuje se SEL-2___00
		movwf DIG1
		movfw RPT2
		movwf DIG2
		movlw .24
		movwf DIG3
		movlw .24
		movwf DIG4
		movlw .2
		movwf DIG5
		movlw .23
		movwf DIG6
		movlw .22
		movwf DIG7
		movlw .21
		movwf DIG8
		movlw .5 
		movwf DIG9
		call ViewNumber
		btfss PORT_A,STD
		clrf CONT
		btfsc PORT_A,STD
		call StdGoes	
		btfss PORT_A,INKEY
		goto Loop4
		goto Mem2No		
Loop4		call Delay
		btfsc PORT_A,INKEY
		goto Mem2No
Loop41		btfss PORT_A,INKEY
		goto Loop41
ShutDown	movlw .23		;Zobrazuje sel ---OFF---
		movwf DIG1
		movlw .23
		movwf DIG2
		movlw .23
		movwf DIG3
		movlw .19
		movwf DIG4
		movlw .19
		movwf DIG5
		movlw .10
		movwf DIG6
		movlw .23
		movwf DIG7
		movlw .23
		movwf DIG8
		movlw .23 
		movwf DIG9
		call ViewNumber
		decfsz SHUT
		goto dobre
		goto spat
dobre		btfss PORT_A,STD
		clrf CONT
		btfsc PORT_A,STD
		call StdGoes	
		btfss PORT_A,INKEY
		goto Loop5
		goto ShutDown		
Loop5		call Delay
		btfsc PORT_A,INKEY
		goto ShutDown
Loop51		btfss PORT_A,INKEY
		goto Loop51
		movlw .255
		movwf SHUT
		goto Viewing
spat		movlw .255
		movwf PORT_B
nonstop		goto nonstop




;**************************************************************************
; PROCEDURY - AKTIVNI PO PRICHODU SIGNALU "STD"
;**************************************************************************
StdGoes		btfsc CONT,0
		return
		bsf CONT,0		;nastavi SC na H
		movlw .255
		TRIS TRIS_B
		movfw NO12
		movwf NO13
		movfw NO11
		movwf NO12
		movfw NO10
		movwf NO11
		movfw NO9
		movwf NO10
		movfw NO8
		movwf NO9
		movfw NO7
		movwf NO8
		movfw NO6
		movwf NO7
		movfw NO5
		movwf NO6
		movfw NO4
		movwf NO5
		movfw NO3 
		movwf NO4
		movfw NO2
		movwf NO3
		movfw NO1
		movwf NO2		;konec presunu cisel na displeji
		movfw PORT_B		;obsah portu B do reg. NO1
		movwf NO1		
		bcf NO1,7		;odstraneni 4 hornich bitu
		bcf NO1,6		
		bcf NO1,5
		bcf NO1,4
		call AddCount		;inkrementuje citac
		call Comp1No		;porovnani 1 cisla
		call Comp2No		;porovnani 2 cisla
		movlw 00h
		movwf NBRS
		return
AddCount	incf JEDN		;citac poctu STD signalu 
		movlw 0Ah
		subwf JEDN,W
		btfss SWR,Z
		return
		clrf JEDN
		incf DESI
		movlw 0Ah
		subwf DESI,W
		btfss SWR,Z
		return
		clrf DESI
		incf STOV
		movlw 0Ah
		subwf STOV,W
		btfss SWR,Z
		return
		clrf STOV
		incf TISI
		movlw 0Ah
		subwf TISI,W
		btfss SWR,Z
		return
		clrf TISI
		incf DESTIS
		movlw 0Ah
		subwf DESTIS,W
		btfss SWR,Z
		return
		clrf JEDN
		clrf DESI
		clrf STOV
		clrf TISI
		clrf DESTIS
		return

Comp1No		movlw 01h		;Nacteni poctu cisel
		movwf EEADR	
		call ReadEE	
		movfw EEDATA		
		movwf NBRS		;ulozeni do NBRS
		movlw 0h
		subwf NBRS,W		;je NBRS=0 nebo ne
		btfsc SWR,Z
		return			;ano
		movlw 06h		;ne => nacteni prvniho cisla
		movwf EEADR
		call ReadEE		
		movfw EEDATA
		subwf NO1,W
		btfss SWR,Z
		return		
		decf NBRS
		movlw 0h
		subwf NBRS,W		;je NBRS=0 nebo ne
		btfsc SWR,Z
		goto Citac1			;ano
		movlw 05h		;nacteni druheho cisla
		movwf EEADR
		call ReadEE		
		movfw EEDATA
		subwf NO2,W
		btfss SWR,Z
		return		
		decf NBRS
		movlw 0h
		subwf NBRS,W		;je NBRS=0 nebo ne
		btfsc SWR,Z
		goto Citac1			;ano
		movlw 04h		;nacteni tretiho cisla
		movwf EEADR
		call ReadEE		
		movfw EEDATA
		subwf NO3,W
		btfss SWR,Z
		return		
		decf NBRS
		movlw 0h
		subwf NBRS,W		;je NBRS=0 nebo ne
		btfsc SWR,Z
		goto Citac1			;ano
		movlw 03h		;nacteni ctvrteho cisla
		movwf EEADR
		call ReadEE		
		movfw EEDATA
		subwf NO4,W
		btfss SWR,Z
		return		
		decf NBRS
		movlw 0h
		subwf NBRS,W		;je NBRS=0 nebo ne
		btfsc SWR,Z
		goto Citac1			;ano
		movlw 02h		;nacteni pateho cisla
		movwf EEADR
		call ReadEE		
		movfw EEDATA
		subwf NO5,W
		btfss SWR,Z
		return		
		decf NBRS
		movlw 0h
		subwf NBRS,W		;je NBRS=0 nebo ne
		btfsc SWR,Z
		goto Citac1			;ano
		return
Citac1		incf SEL1		;inkrementace citace cisla 1
		movlw 0AH
		subwf SEL1,W
		btfss SWR,Z
		return
		clrf SEL1
		incf SEL2
		movlw 0AH
		subwf SEL2,W
		btfss SWR,Z
		return
		clrf SEL1
		clrf SEL2
		return




Comp2No		movlw 11h		;Nacteni poctu cisel
		movwf EEADR	
		call ReadEE	
		movfw EEDATA		
		movwf NBRS		;ulozeni do NBRS
		movlw 0h
		subwf NBRS,W		;je NBRS=0 nebo ne
		btfsc SWR,Z
		return			;ano
		movlw 16h		;ne => nacteni prvniho cisla
		movwf EEADR
		call ReadEE		
		movfw EEDATA
		subwf NO1,W
		btfss SWR,Z
		return		
		decf NBRS
		movlw 0h
		subwf NBRS,W		;je NBRS=0 nebo ne
		btfsc SWR,Z
		goto Citac2			;ano
		movlw 15h		;nacteni druheho cisla
		movwf EEADR
		call ReadEE		
		movfw EEDATA
		subwf NO2,W
		btfss SWR,Z
		return		
		decf NBRS
		movlw 0h
		subwf NBRS,W		;je NBRS=0 nebo ne
		btfsc SWR,Z
		goto Citac2			;ano
		movlw 14h		;nacteni tretiho cisla
		movwf EEADR
		call ReadEE		
		movfw EEDATA
		subwf NO3,W
		btfss SWR,Z
		return		
		decf NBRS
		movlw 0h
		subwf NBRS,W		;je NBRS=0 nebo ne
		btfsc SWR,Z
		goto Citac2			;ano
		movlw 13h		;nacteni ctvrteho cisla
		movwf EEADR
		call ReadEE		
		movfw EEDATA
		subwf NO4,W
		btfss SWR,Z
		return		
		decf NBRS
		movlw 0h
		subwf NBRS,W		;je NBRS=0 nebo ne
		btfsc SWR,Z
		goto Citac2			;ano
		movlw 12h		;nacteni pateho cisla
		movwf EEADR
		call ReadEE		
		movfw EEDATA
		subwf NO5,W
		btfss SWR,Z
		return		
		decf NBRS
		movlw 0h
		subwf NBRS,W		;je NBRS=0 nebo ne
		btfsc SWR,Z
		goto Citac2			;ano
		return
Citac2		incf RPT1		;inkrementace citace cisla 1
		movlw 0AH
		subwf RPT1,W
		btfss SWR,Z
		return
		clrf RPT1
		incf RPT2
		movlw 0AH
		subwf RPT2,W
		btfss SWR,Z
		return
		clrf RPT1
		clrf RPT2
		return

;**************************************************************************
Delay		call Pause
		return
Time		call Pause
		call Pause
		call Pause
		call Pause
		call Pause
Pause 		movlw 0FFh
		movwf COUNT
PauseLoop	decfsz COUNT,f
		goto PauseLoop
		return
;
Roger		movlw .21
		movwf DIG8
		movwf DIG7
		movlw .23
		movwf DIG6
		movwf DIG5
		movwf DIG4
		movwf DIG3
		movwf DIG2
		movwf DIG1
		call ViewNumber
		goto Roger
;
;**********************************************************************
;PROCEDURY PROGRAMOVANI CISEL DO PAMETI
;**********************************************************************
SaveNumber	call Delay
		btfsc PORT_B,SETKEY
		goto Viewing	
		movlw .1		;urceni cisla pameti
		subwf NO8,W
		btfsc SWR,Z
		goto Save1
		movlw .2
		subwf NO8,W
		btfsc SWR,Z
		goto Save2
		goto ShutDown 		
;*********ZAPIS DO EEPROM**************************************
ProgEE		bsf SWR,RP0
		bsf EECON1,WREN
		movlw 55h
		movwf EECON2
		movlw 0AAh
		movwf EECON2
		bsf EECON1,WR
ProgTest	btfsc EECON1,WR
		goto ProgTest
		bcf SWR,RP0
		return
;*********CTENI Z EEPROM***************************************
ReadEE		bsf SWR,RP0
		bsf EECON1,RD
ReadTest	btfsc EECON1,RD
		goto ReadTest
		bcf SWR,RP0
		return
;*********UKLADACI PROCEDURY***********************************
Save1		movfw NO8
		movwf EEDATA
		movlw 00h
		movwf EEADR
		call ProgEE
		movfw NO7
		movwf EEDATA
		movlw 01h
		movwf EEADR
		call ProgEE
		movfw NO6
		movwf EEDATA
		movlw 02h
		movwf EEADR
		call ProgEE
		movfw NO5
		movwf EEDATA
		movlw 03h
		movwf EEADR
		call ProgEE
		movfw NO4
		movwf EEDATA
		movlw 04h
		movwf EEADR
		call ProgEE
		movfw NO3
		movwf EEDATA
		movlw 05h
		movwf EEADR
		call ProgEE
		movfw NO2
		movwf EEDATA
		movlw 06h
		movwf EEADR
		call ProgEE
		goto Roger
;---------------------------------------------------------------
Save2		movfw NO8
		movwf EEDATA
		movlw 10h
		movwf EEADR
		call ProgEE
		movfw NO7
		movwf EEDATA
		movlw 11h
		movwf EEADR
		call ProgEE
		movfw NO6
		movwf EEDATA
		movlw 12h
		movwf EEADR
		call ProgEE
		movfw NO5
		movwf EEDATA
		movlw 13h
		movwf EEADR
		call ProgEE
		movfw NO4
		movwf EEDATA
		movlw 14h
		movwf EEADR
		call ProgEE
		movfw NO3
		movwf EEDATA
		movlw 15h
		movwf EEADR
		call ProgEE
		movfw NO2
		movwf EEDATA
		movlw 16h
		movwf EEADR
		call ProgEE
		goto Roger
;**********************************************************************
Start		movlw b'00001100'
		TRIS TRIS_A
		movlw b'10000000'
		TRIS TRIS_B
		clrf PORT_A
		clrf PORT_B
		clrf INTCON
		movlw .155
		movwf NBRS
		movlw .255
		movwf SHUT
		movlw .24			
		movwf NO1
		movwf NO2
		movwf NO3
		movlw .17
		movwf NO4
		movlw .10
		movwf NO5
		movlw .16
		movwf NO6
		movlw .13
		movwf NO7
		movlw .24
		movwf NO8
		movwf NO9
		movwf NO10
		movwf NO11
		movwf NO12
		movwf NO13
		clrf JEDN
		clrf DESI
		clrf STOV
		clrf TISI
		clrf DESTIS
		clrf SEL1
		clrf SEL2
		clrf RPT1
		clrf RPT2
		clrf CONT
		goto Viewing 
		end